package org.dromara.client.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.client.domain.bo.TPlatformUserBo;
import org.dromara.client.domain.vo.TPlatformUserVo;
import org.dromara.client.domain.TPlatformUser;
import org.dromara.client.mapper.TPlatformUserMapper;
import org.dromara.client.service.ITPlatformUserService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 平台用户关联（微信/抖音小程序用户信息）Service业务层处理
 *
 * @author ZhouWenTao
 * @date 2026-03-22
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class TPlatformUserServiceImpl implements ITPlatformUserService {

    private final TPlatformUserMapper baseMapper;

    /**
     * 查询平台用户关联（微信/抖音小程序用户信息）
     *
     * @param id 主键
     * @return 平台用户关联（微信/抖音小程序用户信息）
     */
    @Override
    public TPlatformUserVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询平台用户关联（微信/抖音小程序用户信息）列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 平台用户关联（微信/抖音小程序用户信息）分页列表
     */
    @Override
    public TableDataInfo<TPlatformUserVo> queryPageList(TPlatformUserBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TPlatformUser> lqw = buildQueryWrapper(bo);
        Page<TPlatformUserVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的平台用户关联（微信/抖音小程序用户信息）列表
     *
     * @param bo 查询条件
     * @return 平台用户关联（微信/抖音小程序用户信息）列表
     */
    @Override
    public List<TPlatformUserVo> queryList(TPlatformUserBo bo) {
        LambdaQueryWrapper<TPlatformUser> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TPlatformUser> buildQueryWrapper(TPlatformUserBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TPlatformUser> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TPlatformUser::getId);
        lqw.eq(bo.getUserId() != null, TPlatformUser::getUserId, bo.getUserId());
        lqw.eq(bo.getPlatformType() != null, TPlatformUser::getPlatformType, bo.getPlatformType());
        lqw.eq(StringUtils.isNotBlank(bo.getPlatformOpenid()), TPlatformUser::getPlatformOpenid, bo.getPlatformOpenid());
        lqw.eq(StringUtils.isNotBlank(bo.getPlatformUnionid()), TPlatformUser::getPlatformUnionid, bo.getPlatformUnionid());
        lqw.eq(StringUtils.isNotBlank(bo.getPlatformSessionKey()), TPlatformUser::getPlatformSessionKey, bo.getPlatformSessionKey());
        lqw.eq(StringUtils.isNotBlank(bo.getPlatformExtra()), TPlatformUser::getPlatformExtra, bo.getPlatformExtra());
        lqw.eq(bo.getLastLoginTime() != null, TPlatformUser::getLastLoginTime, bo.getLastLoginTime());
        return lqw;
    }

    /**
     * 新增平台用户关联（微信/抖音小程序用户信息）
     *
     * @param bo 平台用户关联（微信/抖音小程序用户信息）
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TPlatformUserBo bo) {
        TPlatformUser add = MapstructUtils.convert(bo, TPlatformUser.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改平台用户关联（微信/抖音小程序用户信息）
     *
     * @param bo 平台用户关联（微信/抖音小程序用户信息）
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TPlatformUserBo bo) {
        TPlatformUser update = MapstructUtils.convert(bo, TPlatformUser.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TPlatformUser entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除平台用户关联（微信/抖音小程序用户信息）信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
